"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var NodeReadyMachine_exports = {};
__export(NodeReadyMachine_exports, {
  createNodeReadyMachine: () => createNodeReadyMachine
});
module.exports = __toCommonJS(NodeReadyMachine_exports);
var import_xstate = require("xstate");
function createNodeReadyMachine(initialContext = {}) {
  return (0, import_xstate.Machine)({
    id: "nodeReady",
    initial: "notReady",
    context: {
      isMaybeDead: true,
      ...initialContext
    },
    on: {
      MAYBE_DEAD: {
        actions: (0, import_xstate.assign)({ isMaybeDead: true })
      },
      NOT_DEAD: {
        actions: (0, import_xstate.assign)({ isMaybeDead: false })
      },
      INTERVIEW_DONE: {
        target: "ready",
        actions: (0, import_xstate.assign)({ isMaybeDead: false })
      }
    },
    states: {
      notReady: {
        entry: (0, import_xstate.assign)({ isMaybeDead: true }),
        on: {
          RESTART_FROM_CACHE: [{ target: "readyIfNotDead" }]
        }
      },
      readyIfNotDead: {
        always: [{ cond: "isDefinitelyNotDead", target: "ready" }],
        on: {
          NOT_DEAD: {
            target: "ready",
            actions: (0, import_xstate.assign)({ isMaybeDead: false })
          }
        }
      },
      ready: {
        // If this is final, we will get warnings in the log
        // So don't :)
      }
    }
  }, {
    guards: {
      isDefinitelyNotDead: /* @__PURE__ */ __name((ctx) => !ctx.isMaybeDead, "isDefinitelyNotDead")
    }
  });
}
__name(createNodeReadyMachine, "createNodeReadyMachine");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createNodeReadyMachine
});
//# sourceMappingURL=NodeReadyMachine.js.map
