"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var NodeStatusMachine_exports = {};
__export(NodeStatusMachine_exports, {
  createNodeStatusMachine: () => createNodeStatusMachine,
  nodeStatusMachineStateToNodeStatus: () => nodeStatusMachineStateToNodeStatus
});
module.exports = __toCommonJS(NodeStatusMachine_exports);
var import_xstate = require("xstate");
var import_Types = require("./_Types.js");
const statusDict = {
  unknown: import_Types.NodeStatus.Unknown,
  dead: import_Types.NodeStatus.Dead,
  alive: import_Types.NodeStatus.Alive,
  asleep: import_Types.NodeStatus.Asleep,
  awake: import_Types.NodeStatus.Awake
};
function nodeStatusMachineStateToNodeStatus(state) {
  return statusDict[state] ?? import_Types.NodeStatus.Unknown;
}
__name(nodeStatusMachineStateToNodeStatus, "nodeStatusMachineStateToNodeStatus");
function createNodeStatusMachine(node) {
  return (0, import_xstate.Machine)({
    id: "nodeStatus",
    initial: "unknown",
    states: {
      unknown: {
        on: {
          DEAD: {
            target: "dead",
            cond: "cannotSleep"
          },
          ALIVE: {
            target: "alive",
            cond: "cannotSleep"
          },
          ASLEEP: {
            target: "asleep",
            cond: "canSleep"
          },
          AWAKE: {
            target: "awake",
            cond: "canSleep"
          }
        }
      },
      dead: {
        on: {
          ALIVE: "alive"
        }
      },
      alive: {
        on: {
          DEAD: "dead",
          // GH#1054 we must have a way to send a node to sleep even if
          // it was previously detected as a non-sleeping device
          ASLEEP: {
            target: "asleep",
            cond: "canSleep"
          },
          AWAKE: {
            target: "awake",
            cond: "canSleep"
          }
        }
      },
      asleep: {
        on: {
          AWAKE: "awake"
        }
      },
      awake: {
        on: {
          ASLEEP: "asleep"
        }
      }
    }
  }, {
    guards: {
      canSleep: /* @__PURE__ */ __name(() => !!node.canSleep, "canSleep"),
      cannotSleep: /* @__PURE__ */ __name(() => !node.canSleep, "cannotSleep")
    }
  });
}
__name(createNodeStatusMachine, "createNodeStatusMachine");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createNodeStatusMachine,
  nodeStatusMachineStateToNodeStatus
});
//# sourceMappingURL=NodeStatusMachine.js.map
