"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var MockSerialPort_exports = {};
__export(MockSerialPort_exports, {
  MockSerialPort: () => MockSerialPort,
  createAndOpenMockedZWaveSerialPort: () => createAndOpenMockedZWaveSerialPort
});
module.exports = __toCommonJS(MockSerialPort_exports);
var import_core = require("@zwave-js/core");
var import_shared = require("@zwave-js/shared");
var import_node_events = require("node:events");
var import_node_stream = require("node:stream");
var import_sinon = __toESM(require("sinon"), 1);
var import_ZWaveSerialPort = require("../serialport/ZWaveSerialPort.js");
var import_SerialPortBindingMock = require("./SerialPortBindingMock.js");
var import_SerialPortMock = require("./SerialPortMock.js");
var __esDecorate = function(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
  function accept(f) {
    if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected");
    return f;
  }
  __name(accept, "accept");
  var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
  var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
  var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
  var _, done = false;
  for (var i = decorators.length - 1; i >= 0; i--) {
    var context = {};
    for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
    for (var p in contextIn.access) context.access[p] = contextIn.access[p];
    context.addInitializer = function(f) {
      if (done) throw new TypeError("Cannot add initializers after decoration has completed");
      extraInitializers.push(accept(f || null));
    };
    var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
    if (kind === "accessor") {
      if (result === void 0) continue;
      if (result === null || typeof result !== "object") throw new TypeError("Object expected");
      if (_ = accept(result.get)) descriptor.get = _;
      if (_ = accept(result.set)) descriptor.set = _;
      if (_ = accept(result.init)) initializers.unshift(_);
    } else if (_ = accept(result)) {
      if (kind === "field") initializers.unshift(_);
      else descriptor[key] = _;
    }
  }
  if (target) Object.defineProperty(target, contextIn.name, descriptor);
  done = true;
};
var __runInitializers = function(thisArg, initializers, value) {
  var useValue = arguments.length > 2;
  for (var i = 0; i < initializers.length; i++) {
    value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
  }
  return useValue ? value : void 0;
};
const instances = /* @__PURE__ */ new Map();
let MockBinding = (() => {
  let _classDecorators = [(0, import_shared.Mixin)([import_node_events.EventEmitter])];
  let _classDescriptor;
  let _classExtraInitializers = [];
  let _classThis;
  let _classSuper = import_node_stream.PassThrough;
  var MockBinding2 = class extends _classSuper {
    static {
      __name(this, "MockBinding");
    }
    static {
      _classThis = this;
    }
    static {
      const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
      __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
      MockBinding2 = _classThis = _classDescriptor.value;
      if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
      __runInitializers(_classThis, _classExtraInitializers);
    }
  };
  return MockBinding2 = _classThis;
})();
class MockSerialPort extends import_ZWaveSerialPort.ZWaveSerialPort {
  static {
    __name(this, "MockSerialPort");
  }
  constructor(port, loggers) {
    super(port, loggers, MockBinding);
    instances.set(port, this);
  }
  static getInstance(port) {
    return instances.get(port);
  }
  __isOpen = false;
  get isOpen() {
    return this.__isOpen;
  }
  open() {
    return this.openStub().then(() => {
      this.__isOpen = true;
    });
  }
  openStub = import_sinon.default.stub().resolves();
  close() {
    return this.closeStub().then(() => {
      this.__isOpen = false;
    });
  }
  closeStub = import_sinon.default.stub().resolves();
  receiveData(data) {
    this.serial.emit("data", data);
  }
  raiseError(err) {
    this.emit("error", err);
  }
  writeAsync(data) {
    this._lastWrite = data;
    this.emit("write", data);
    return this.writeStub(data);
  }
  writeStub = import_sinon.default.stub();
  _lastWrite;
  get lastWrite() {
    return this._lastWrite;
  }
}
async function createAndOpenMockedZWaveSerialPort(path) {
  import_SerialPortBindingMock.MockBinding.reset();
  import_SerialPortBindingMock.MockBinding.createPort(path, {
    record: true,
    readyData: new Uint8Array()
  });
  const port = new import_ZWaveSerialPort.ZWaveSerialPort(
    path,
    new import_core.ZWaveLogContainer({
      enabled: false
    }),
    // @ts-expect-error We're using an internal signature here
    import_SerialPortMock.SerialPortMock
  );
  await port.open();
  const binding = port["serial"].port;
  return { port, binding };
}
__name(createAndOpenMockedZWaveSerialPort, "createAndOpenMockedZWaveSerialPort");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  MockSerialPort,
  createAndOpenMockedZWaveSerialPort
});
//# sourceMappingURL=MockSerialPort.js.map
