"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var ZWaveSerialPortBase_exports = {};
__export(ZWaveSerialPortBase_exports, {
  ZWaveSerialMode: () => ZWaveSerialMode,
  ZWaveSerialPortBase: () => ZWaveSerialPortBase
});
module.exports = __toCommonJS(ZWaveSerialPortBase_exports);
var import_shared = require("@zwave-js/shared");
var import_node_events = require("node:events");
var import_node_stream = require("node:stream");
var import_Logger = require("../log/Logger.js");
var import_MessageHeaders = require("../message/MessageHeaders.js");
var import_BootloaderParsers = require("../parsers/BootloaderParsers.js");
var import_SerialAPIParser = require("../parsers/SerialAPIParser.js");
var __esDecorate = function(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
  function accept(f) {
    if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected");
    return f;
  }
  __name(accept, "accept");
  var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
  var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
  var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
  var _, done = false;
  for (var i = decorators.length - 1; i >= 0; i--) {
    var context = {};
    for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
    for (var p in contextIn.access) context.access[p] = contextIn.access[p];
    context.addInitializer = function(f) {
      if (done) throw new TypeError("Cannot add initializers after decoration has completed");
      extraInitializers.push(accept(f || null));
    };
    var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
    if (kind === "accessor") {
      if (result === void 0) continue;
      if (result === null || typeof result !== "object") throw new TypeError("Object expected");
      if (_ = accept(result.get)) descriptor.get = _;
      if (_ = accept(result.set)) descriptor.set = _;
      if (_ = accept(result.init)) initializers.unshift(_);
    } else if (_ = accept(result)) {
      if (kind === "field") initializers.unshift(_);
      else descriptor[key] = _;
    }
  }
  if (target) Object.defineProperty(target, contextIn.name, descriptor);
  done = true;
};
var __runInitializers = function(thisArg, initializers, value) {
  var useValue = arguments.length > 2;
  for (var i = 0; i < initializers.length; i++) {
    value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
  }
  return useValue ? value : void 0;
};
var ZWaveSerialMode;
(function(ZWaveSerialMode2) {
  ZWaveSerialMode2[ZWaveSerialMode2["SerialAPI"] = 0] = "SerialAPI";
  ZWaveSerialMode2[ZWaveSerialMode2["Bootloader"] = 1] = "Bootloader";
})(ZWaveSerialMode || (ZWaveSerialMode = {}));
const IS_TEST = process.env.NODE_ENV === "test" || !!process.env.CI;
let ZWaveSerialPortBase = (() => {
  let _classDecorators = [(0, import_shared.Mixin)([import_node_events.EventEmitter])];
  let _classDescriptor;
  let _classExtraInitializers = [];
  let _classThis;
  let _classSuper = import_node_stream.PassThrough;
  var ZWaveSerialPortBase2 = class extends _classSuper {
    static {
      __name(this, "ZWaveSerialPortBase");
    }
    static {
      _classThis = this;
    }
    static {
      const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
      __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
      ZWaveSerialPortBase2 = _classThis = _classDescriptor.value;
      if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
      __runInitializers(_classThis, _classExtraInitializers);
    }
    implementation;
    serial;
    logger;
    // Serial API parser
    parser;
    // Bootloader parsers
    bootloaderScreenParser;
    bootloaderParser;
    // Allow switching between modes
    mode;
    // Allow ignoring the high nibble of an ACK once to work around an issue in the 700 series firmware
    ignoreAckHighNibbleOnce() {
      this.parser.ignoreAckHighNibble = true;
    }
    constructor(implementation, loggers) {
      super({ readableObjectMode: true });
      this.implementation = implementation;
      for (const method of [
        "on",
        "once",
        "off",
        "addListener",
        "removeListener",
        "removeAllListeners"
      ]) {
        const original = this[method].bind(this);
        this[method] = (event, ...args) => {
          if (event === "data") {
            this.parser[method]("data", ...args);
          } else if (event === "bootloaderData") {
            this.bootloaderParser[method]("data", ...args);
          } else {
            original(event, ...args);
          }
          return this;
        };
      }
      this.logger = new import_Logger.SerialLogger(loggers);
      this.serial = implementation.create().on("error", (e) => {
        this.emit("error", e);
      });
      this.parser = new import_SerialAPIParser.SerialAPIParser(this.logger, (discarded) => this.emit("discardedData", discarded));
      this.bootloaderScreenParser = new import_BootloaderParsers.BootloaderScreenParser(this.logger);
      this.bootloaderParser = new import_BootloaderParsers.BootloaderParser();
      this.bootloaderScreenParser.pipe(this.bootloaderParser);
      this.serial.on("data", (data) => {
        if (this.mode == void 0) {
          const buffer = import_shared.Bytes.view(data);
          const str = buffer.toString("ascii").replaceAll(/^[\s\0]+|[\s\0]+$/g, "");
          if (str.startsWith(import_BootloaderParsers.bootloaderMenuPreamble)) {
            this.mode = ZWaveSerialMode.Bootloader;
          } else if (buffer.every((b) => b === 0 || b === 10 || b === 13 || b >= 32 && b <= 126) && buffer.some((b) => b >= 32 && b <= 126)) {
            this.mode = ZWaveSerialMode.Bootloader;
          } else {
            this.mode = ZWaveSerialMode.SerialAPI;
          }
        }
        const write = /* @__PURE__ */ __name(() => {
          if (this.mode === ZWaveSerialMode.Bootloader) {
            this.bootloaderScreenParser.write(data);
          } else {
            this.parser.write(data);
          }
        }, "write");
        if (IS_TEST) {
          write();
        } else {
          setImmediate(write);
        }
      });
      this.on("pipe", (source) => {
        source.unpipe(this);
        source.pipe(this.serial, { end: false });
      });
      this.pipe = this.parser.pipe.bind(this.parser);
      this.unpipe = (destination) => {
        this.parser.unpipe(destination);
        return this;
      };
      this[Symbol.asyncIterator] = () => this.parser[Symbol.asyncIterator]();
    }
    async open() {
      await this.implementation.open(this.serial);
      this._isOpen = true;
    }
    close() {
      this._isOpen = false;
      return this.implementation.close(this.serial);
    }
    _isOpen = false;
    get isOpen() {
      return this._isOpen;
    }
    async writeAsync(data) {
      if (!this.isOpen) {
        throw new Error("The serial port is not open!");
      }
      if (this.mode === ZWaveSerialMode.SerialAPI && data.length === 1) {
        switch (data[0]) {
          case import_MessageHeaders.MessageHeaders.ACK:
            this.logger.ACK("outbound");
            break;
          case import_MessageHeaders.MessageHeaders.CAN:
            this.logger.CAN("outbound");
            break;
          case import_MessageHeaders.MessageHeaders.NAK:
            this.logger.NAK("outbound");
            break;
        }
      } else {
        this.logger.data("outbound", data);
      }
      return new Promise((resolve, reject) => {
        this.serial.write(data, (err) => {
          if (err)
            reject(err);
          else
            resolve();
        });
      });
    }
  };
  return ZWaveSerialPortBase2 = _classThis;
})();
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ZWaveSerialMode,
  ZWaveSerialPortBase
});
//# sourceMappingURL=ZWaveSerialPortBase.js.map
