"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var ZnifferSerialPort_exports = {};
__export(ZnifferSerialPort_exports, {
  ZnifferSerialPort: () => ZnifferSerialPort
});
module.exports = __toCommonJS(ZnifferSerialPort_exports);
var import_core = require("@zwave-js/core");
var import_serialport = require("serialport");
var import_ZnifferSerialPortBase = require("./ZnifferSerialPortBase.js");
class ZnifferSerialPort extends import_ZnifferSerialPortBase.ZnifferSerialPortBase {
  static {
    __name(this, "ZnifferSerialPort");
  }
  constructor(port, loggers, Binding = import_serialport.SerialPort) {
    let removeListeners;
    super({
      create: /* @__PURE__ */ __name(() => new Binding({
        path: port,
        autoOpen: false,
        baudRate: 115200,
        dataBits: 8,
        stopBits: 1,
        parity: "none"
      }), "create"),
      open: /* @__PURE__ */ __name((serial) => new Promise((resolve, reject) => {
        const onClose = /* @__PURE__ */ __name((err) => {
          if (err?.disconnected === true) {
            removeListeners(true);
            this.emit("error", new import_core.ZWaveError(`The serial port closed unexpectedly!`, import_core.ZWaveErrorCodes.Driver_Failed));
          }
        }, "onClose");
        const onError = /* @__PURE__ */ __name((err) => {
          removeListeners(true);
          reject(err);
        }, "onError");
        const onOpen = /* @__PURE__ */ __name(() => {
          removeListeners(false);
          resolve();
        }, "onOpen");
        removeListeners = /* @__PURE__ */ __name((removeOnClose) => {
          if (removeOnClose) {
            serial.removeListener("close", onClose);
          }
          serial.removeListener("error", onError);
          serial.removeListener("open", onOpen);
        }, "removeListeners");
        serial.once("close", onClose);
        serial.once("error", onError);
        serial.once("open", onOpen).open();
      }), "open"),
      close: /* @__PURE__ */ __name((serial) => new Promise((resolve) => {
        removeListeners(true);
        serial.once("close", resolve).close();
      }), "close")
    }, loggers);
  }
  get isOpen() {
    return this.serial.isOpen;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ZnifferSerialPort
});
//# sourceMappingURL=ZnifferSerialPort.js.map
