"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var ZnifferSocket_exports = {};
__export(ZnifferSocket_exports, {
  ZnifferSocket: () => ZnifferSocket
});
module.exports = __toCommonJS(ZnifferSocket_exports);
var import_core = require("@zwave-js/core");
var net = __toESM(require("node:net"), 1);
var import_ZnifferSerialPortBase = require("./ZnifferSerialPortBase.js");
class ZnifferSocket extends import_ZnifferSerialPortBase.ZnifferSerialPortBase {
  static {
    __name(this, "ZnifferSocket");
  }
  socketOptions;
  constructor(socketOptions, loggers) {
    let removeListeners;
    super({
      create: /* @__PURE__ */ __name(() => new net.Socket(), "create"),
      open: /* @__PURE__ */ __name((serial) => new Promise((resolve, reject) => {
        const onClose = /* @__PURE__ */ __name(() => {
          this.emit("error", new import_core.ZWaveError(`The socket closed unexpectedly!`, import_core.ZWaveErrorCodes.Driver_Failed));
        }, "onClose");
        const onError = /* @__PURE__ */ __name((err) => {
          removeListeners(true);
          reject(err);
        }, "onError");
        const onConnect = /* @__PURE__ */ __name(() => {
          serial.setKeepAlive(true, 2500);
          removeListeners(false);
          resolve();
        }, "onConnect");
        removeListeners = /* @__PURE__ */ __name((removeOnClose) => {
          if (removeOnClose) {
            serial.removeListener("close", onClose);
          }
          serial.removeListener("error", onError);
          serial.removeListener("connect", onConnect);
        }, "removeListeners");
        serial.once("close", onClose);
        serial.once("error", onError);
        serial.once("connect", onConnect);
        serial.connect(this.socketOptions);
      }), "open"),
      close: /* @__PURE__ */ __name((serial) => new Promise((resolve) => {
        removeListeners(true);
        if (serial.destroyed) {
          resolve();
        } else {
          serial.once("close", () => resolve()).destroy();
        }
      }), "close")
    }, loggers);
    this.socketOptions = socketOptions;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ZnifferSocket
});
//# sourceMappingURL=ZnifferSocket.js.map
